/*
 * AbsorbTerminalSymbol.h
 *
 *  Created on: 9. 6. 2015
 *	  Author: Jan Travnicek
 */

#ifndef ABSORB_TERMINAL_SYMBOL_H_
#define ABSORB_TERMINAL_SYMBOL_H_

#include <grammar/GrammarFeatures.h>
#include <alphabet/Symbol.h>
#include <set>
#include <map>

namespace grammar {

namespace parsing {

class AbsorbTerminalSymbol {
public:
	static void handleAbsobtion ( const grammar::CFG < > & orig, grammar::CFG < > & res, const DefaultSymbolType & terminal, const ext::set < DefaultSymbolType > & nonterminals, const ext::map < DefaultSymbolType, DefaultSymbolType > & nonterminalPrimed );

	static void absorbTerminalSymbol ( grammar::CFG < > & grammar, const DefaultSymbolType & terminal, const ext::set < DefaultSymbolType > & nonterminals );
};

} /* namespace parsing */

} /* namespace grammar */

#endif /* ABSORB_TERMINAL_SYMBOL_H_ */
